package EditDNS;

use strict;

use LWP::UserAgent;
use Data::Dumper;


# Este metodo recebe dois argumentos: hostname a actualizar e respectiva
# password.

sub change_domain {
    my $ns = shift;
    my $password = shift;
    my $home = $ENV{'HOME'};
    my $ip_detect = $ENV{'URL_IP_DETECT'} || 'http://ipdetect.dnspark.com/';
    my $ip_update = $ENV{'URL_IP_UPDATE'} ||
        'http://DynDNS.EditDNS.net/api/dynLinux.php';

    my $fh;
    my $user_agent = LWP::UserAgent->new();
    
    my $response = $user_agent->get($ip_detect);
    my ($ip) = $response->{'_content'} =~ /Current Address: +(([0-9]{1,3}\.){3}[0-9]{1,3})/m;
    if (!$ip) {
        print STDERR "Unable to get current IP address.\n";
        return 0;
    }
    
    open($fh, '<', "$home/.ns_last_changes.$ns") or $fh = undef;
    if ($fh) {
        foreach (<$fh>) {
            if ($_ =~ /^$ns:$ip$/) {
                print "Same IP. No update needed.\n";
                close($fh);
                return 0;
            }
        }
        close($fh);
    }
    
    print "Updating NS: $ns ($ip)\n";
    
    $response = $user_agent->post($ip_update, {
        'p' => $password,
        'r' => $ns,
    });
    
    open($fh, '>>', "$home/.ns_history.$ns");
    my @momento = localtime;
    $momento[4]++;
    foreach (@momento) {
        $_ = sprintf("0%d", $_) if ($_ < 10);
    }
    print $fh (1900+$momento[5]) . '-' . $momento[4] . '-' . $momento[3] . ',' .
              $momento[2] . ':' . $momento[1] . ':' . $momento[0] . ',' . $ip . "\n";
    close($fh);
    
    open($fh, '>', "$home/.ns_last_changes.$ns");
    print $fh "$ns:$ip\n";
    close($fh);
    return 1;
}

1;

